unit U_CPBRKListSEL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit,
  cxContainer, cxImage, cxDBEdit, cxPC, Math, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator, dxBarBuiltInMenu;

type
  TfrmCPBRKListSEL = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Label7: TLabel;
    OrderNo: TEdit;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Label9: TLabel;
    spcode: TEdit;
    Panel2: TPanel;
    Picture4: TcxDBImage;
    ADOQueryImage: TADOQuery;
    DSImage: TDataSource;
    v1Column21: TcxGridDBColumn;
    CDS_MX: TClientDataSet;
    DS_MX: TDataSource;
    cxGridPopupMenu2: TcxGridPopupMenu;
    cxTabControl1: TcxTabControl;
    Panel3: TPanel;
    Label25: TLabel;
    btnChk: TButton;
    Button3: TButton;
    MMJYNote: TMemo;
    edtSPID: TEdit;
    v1Column20: TcxGridDBColumn;
    ADOQueryPrint: TADOQuery;
    v1Column22: TcxGridDBColumn;
    Label4: TLabel;
    CustomerNoName: TComboBox;
    Panel4: TPanel;
    cxGrid1: TcxGrid;
    TvMX: TcxGridDBTableView;
    vMXColumn1: TcxGridDBColumn;
    cxGridDBColumn8: TcxGridDBColumn;
    vMXColumn2: TcxGridDBColumn;
    vMXColumn3: TcxGridDBColumn;
    cxGridLevel2: TcxGridLevel;
    ToolBar2: TToolBar;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Label3: TLabel;
    SPColor: TEdit;
    TvMXColumn1: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Tv1Column2: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);

    procedure SPIDKeyPress(Sender: TObject; var Key: Char);
    procedure SPIDChange(Sender: TObject);
    procedure SPSpecChange(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure Tv1CellClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
    procedure FormResize(Sender: TObject);
    procedure btnEditForFacClick(Sender: TObject);
    procedure TvMXCustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
    procedure Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
    procedure btnJYCXClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);

    procedure btnChkClick(Sender: TObject);
    procedure btnJYClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);

  private
    canshu2: string;
    procedure InitGrid();
    procedure InitImage(fsubID: string);
    procedure InitMXGrid(MCRNO: string);
    procedure SetStatus();

    { Private declarations }
  public
    { Public declarations }
    canshu1: string;
  end;

var
  frmCPBRKListSEL: TfrmCPBRKListSEL;

implementation

uses
  U_DataLink, U_RTFun, U_ZdyAttachGYS, U_Fun;

{$R *.dfm}
procedure TfrmCPBRKListSEL.SetStatus();
begin

end;

procedure TfrmCPBRKListSEL.InitMXGrid(MCRNO: string);
begin
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CK_SXPB_CRMX where CRNO=' + quotedstr(Trim(MCRNO)));
    sql.Add(' order by MXID');
    Open;
  end;
//  with ADOQueryTemp do
//  begin
//    Close;
//    sql.Clear;
//    sql.Add('DELETE CK_SXPB_CRMX where crno=' + quotedstr(Trim(cds_main.FieldByName('spid').AsString)));
//    sql.Add(' AND (MXQTY=0 and mxqty2=0)');
////    ShowMessage(sql.Text);
//    EXECSQL;
//  end;
  SCreateCDS20(ADOQueryTemp, CDS_MX);
  SInitCDSData20(ADOQueryTemp, CDS_MX);
end;

procedure TfrmCPBRKListSEL.InitImage(fsubID: string);
begin
  ADOQueryImage.close;
 // IF fwbid='' then exit;
  with ADOQueryImage do
  begin
    close;
    sql.Clear;
    sql.Add('select * from TP_File A');
    sql.Add('inner join JYOrder_Sub B on B.HXFile=A.WBID');
    sql.Add('where B.SubID=' + quotedstr(trim(fsubID)));
    open;
  end;
end;

procedure TfrmCPBRKListSEL.FormDestroy(Sender: TObject);
begin
  frmCPBRKListsel := nil;
end;

procedure TfrmCPBRKListSEL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmCPBRKListSEL.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 7;
end;

procedure TfrmCPBRKListSEL.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      SQL.Add(',prtecolor=(SELECT prtecolor FROM JYORDER_SUB D WHERE D.SUBID=A.ORDSUBIDRK)');
      SQL.Add(',FQTY=(CASE WHEN qtyunit=''KG'' THEN (SELECT SUM(MXQTY2) FROM CK_SXPB_CRMX D WHERE D.CRNO=A.SPID)');
      SQL.Add('WHEN qtyunit=''M'' OR qtyunit=''Y'' THEN (SELECT SUM(MXQTY) FROM CK_SXPB_CRMX D WHERE D.CRNO=A.SPID) END )');

      SQL.Add(',FUNIT=(CASE WHEN qtyunit=''KG'' THEN (SELECT TOP 1 MXUnit FROM CK_SXPB_CRMX D WHERE D.CRNO=A.SPID)');
      SQL.Add('WHEN qtyunit=''M'' OR qtyunit=''Y'' THEN ''KG'' END )');
      sql.Add(',ISSC=cast((case when isnull((select count(WBID) from TP_File X where X.WBID=A.spid and X.TFType=''成品入库''),0)>0 then 1 else 0 end) as bit)');
      sql.Add(' from CK_SXPB_CR A');
      sql.add(' where A.CRTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.CRTime<=''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(CKName,'''')=''成品布''');
      SQL.Add(' and CRFlag=''入库''  ');

      case cxTabControl1.TabIndex of
        0:
          begin
            SQL.Add(' and isnull(chkstatus,0)=''0''  ');
          end;
        1:
          begin
            SQL.Add(' and isnull(chkstatus,0)=''1''  ');
          end;
      end;
      if canshu1 = '低权限' then
      begin
        sql.Add('and ToFactoryName=' + QuotedStr(Trim(DName)));
      end;
//      if canshu1 <> '管理' then
//      begin
//        SQL.Add('AND (FILLER =' + QuotedStr(Trim(dname)));
//        sql.Add('or (select lidan from JYOrder_Main c where c.orderno=a.qcorderno)=' + QuotedStr(Trim(dname)));
//        sql.Add('or (select ywy from JYOrder_Main c where c.orderno=a.qcorderno)=' + QuotedStr(Trim(dname)));
//        sql.Add(')');
//      end;
//      ShowMessage(SQL.Text);
      Open;

    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmCPBRKListSEL.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmCPBRKListSEL.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmCPBRKListSEL.TBCloseClick(Sender: TObject);
begin

  WriteCxGrid(Trim(Self.Caption) + 'Tv1', Tv1, '待检布仓库0327');
  WriteCxGrid(Trim(Self.Caption) + 'Tv2', TvMX, '待检布仓库0327');
  Close;
end;

procedure TfrmCPBRKListSEL.FormShow(Sender: TObject);
var
  fsj: string;
begin
  SetStatus();
  ReadCxGrid(Trim(Self.Caption) + 'Tv1', Tv1, '待检布仓库0327');
  ReadCxGrid(Trim(Self.Caption) + 'Tv2', TvMX, '待检布仓库0327');
  fsj := 'select distinct(CustomerNoName) Name from CK_SXPB_CR  order by CustomerNoName ';
  SInitComBoxBySql(ADOQueryCmd, CustomerNoName, False, fsj);

  InitGrid();
end;

procedure TfrmCPBRKListSEL.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('待检布入库列表', cxGrid2);
end;

procedure TfrmCPBRKListSEL.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmCPBRKListSEL.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmCPBRKListSEL.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmCPBRKListSEL.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
  begin
    if Trim(CDS_Main.fieldbyname('CRType').AsString) = '平移入库' then
    begin
      Application.MessageBox('平移入库的数据为自动生成，不能删除!', '提示', 0);
      Exit;
    end;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
      Exit;
    end;
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;

      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        sql.Add(' delete CK_SXPB_CRMX where CRNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        ExecSQL;
//        if UpdateSXPB(ADOQueryCmd, Trim(CDS_Main.fieldbyname('ORDMainIdRK').AsString), Trim(CDS_Main.fieldbyname('ORDSubIdRK').AsString)) = False then
//        begin
//          ADOQueryCmd.Connection.RollbackTrans;
//          Application.MessageBox('更新进度失败!', '提示', 0);
//          Exit;
//        end;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!', '提示', 0);
    end;

  end
  else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmCPBRKListSEL.SPIDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    {if Length(Trim(SPID.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        sql.Add(',ConNo=(select ConNo from Contract_Main CM where CM.MainId=A.CGMainId)');
        //sql.Add(' ,ConNo=(select ConNo from Contract_Main CM where CM.MainId=A.CGMainId )');
        sql.Add(' from CK_SXPB_CR A');
        sql.add(' where SPID like :SXID');
        Parameters.ParamByName('SXID').Value:='%'+Trim(SXID.Text)+'%';
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end; }
  end;
end;

procedure TfrmCPBRKListSEL.SPIDChange(Sender: TObject);
begin

  TBFind.Click;
end;

procedure TfrmCPBRKListSEL.SPSpecChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmCPBRKListSEL.FactoryNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmCPBRKListSEL.Tv1CellClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
begin
//  ADOQueryImage.Close;
//  IF CDS_Main.IsEmpty then exit;
//  InitImage(CDS_Main.fieldbyname('OrdSubIdRK').AsString);
end;

procedure TfrmCPBRKListSEL.FormResize(Sender: TObject);
begin
  Panel2.Left := self.Width - Panel2.Width - 30;
  Panel2.Top := self.Height - Panel2.Height - 80;
  Panel3.Left := Ceil((self.Width - Panel3.Width) / 2) - 30;
  Panel3.Top := Ceil((self.Height - Panel3.Height) / 2) - 80;

end;

procedure TfrmCPBRKListSEL.btnEditForFacClick(Sender: TObject);
begin
  try
    frmZdyAttachGYS := TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal = 1 then
      begin
        with ADOQueryCmd do
        begin
          close;
          sql.Clear;
          sql.Add('exec P_Update_SXPB_Factory ' + quotedstr(trim(Self.CDS_Main.FieldByName('SPID').AsString)) + ',' + quotedstr(Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString)) + ',' + quotedstr(Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString)));
//          ShowMessage(SQL.Text);
          execsql;
        end;
        with ADOQueryCmd do
        begin
          close;
          sql.Clear;
          sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
          sql.Add(' ' + quotedstr(trim(DName)));
          sql.Add(',getdate() ');
          sql.Add(',' + quotedstr(trim(self.Caption)));
          sql.Add(',' + quotedstr(trim('修改加工厂')));
          sql.Add(',' + quotedstr(trim('入库单号：' + trim(Self.CDS_Main.FieldByName('SPID').AsString) + ' 原加工厂:' + trim(Self.CDS_Main.FieldByName('FactoryName').AsString))));
          sql.Add(',' + quotedstr(trim('成功')));
          sql.Add(')');
          execsql;
        end;

      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmCPBRKListSEL.TvMXCustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
var
  FValue: string;
  FBounds: TRect;
begin
  FBounds := AViewInfo.Bounds;
  if (AViewInfo is TcxGridIndicatorRowItemViewInfo) then
  begin
    ACanvas.FillRect(FBounds);
    ACanvas.DrawComplexFrame(FBounds, clBtnHighlight, clBtnShadow, [bBottom, bLeft, bRight], 1);
    FValue := IntToStr(TcxGridIndicatorRowItemViewInfo(AViewInfo).GridRecord.Index + 1);
    InflateRect(FBounds, -1, -1);    //Platform   specific.   May   not   work   on   Linux.
    ACanvas.Font.Color := clBlack;
    ACanvas.Brush.Style := bsClear;
    ACanvas.DrawText(FValue, FBounds, cxAlignCenter or cxAlignTop);
    ADone := True;
  end;
end;

procedure TfrmCPBRKListSEL.Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
begin
  InitMXGrid(Trim(CDS_Main.fieldbyname('SPID').AsString));
end;

procedure TfrmCPBRKListSEL.btnJYCXClick(Sender: TObject);
begin
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  CK_SXPB_CR SET chkstatus=''0'',Chktime=null ,Chker= null');
      sql.Add('where SPID=' + quotedstr(trim(CDS_Main.fieldbyname('SPID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('撤销入库审核')));
      sql.Add(',' + quotedstr(trim('入库单号：' + trim(CDS_Main.FieldByName('SPID').AsString))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('撤销检验成功！', '提示信息');
    CDS_Main.Delete;
  except
    application.MessageBox('撤销检验失败！', '提示信息', 0);
  end;
end;

procedure TfrmCPBRKListSEL.Button3Click(Sender: TObject);
begin
  Panel3.Visible := False;
end;

procedure TfrmCPBRKListSEL.btnChkClick(Sender: TObject);
begin
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  CK_SXPB_CR SET chkstatus=''1'',Chktime=getdate() ');
      sql.Add(',Chker=' + quotedstr(Trim(DName)));
      sql.Add(',JYNote=' + quotedstr(Trim(MMJYNote.Text)));
      sql.Add('where SPID=' + quotedstr(trim(edtSPID.Text)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' ' + quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(trim('入库审核')));
      sql.Add(',' + quotedstr(trim('入库单号：' + trim(edtSPID.Text))));
      sql.Add(',' + quotedstr(trim('成功')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('检验成功！', '提示信息');
    CDS_Main.Delete;

    Panel3.Visible := False;
  except
    application.MessageBox('检验失败！', '提示信息', 0);
  end;
end;

procedure TfrmCPBRKListSEL.btnJYClick(Sender: TObject);
begin
  edtSPID.Text := Trim(Self.CDS_Main.fieldbyname('SPID').AsString);
  MMJYNote.Text := Trim(Self.CDS_Main.fieldbyname('JYNote').AsString);
  Panel3.Visible := true;
end;

procedure TfrmCPBRKListSEL.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();
  InitGrid();
end;

procedure TfrmCPBRKListSEL.ToolButton1Click(Sender: TObject);
begin

  if CDS_Main.IsEmpty = true then
  begin
    Exit;
  end;
  ModalResult := 1;
end;

end.

